#    uwss - uber web security scanner
#    Copyright (C) 2009 noptrix & illuminatus
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
# uAttack.py
#
# by noptrix & illuminatus
# www.noptrix.net


# uwss imports
from uAttack import *
from ucrawler.uCrawler import *


class AttackDynamicKeys(Attack):
   """
   Attack class when dealing with forms which implement dynamic keys.
   Therefor we'll first have to load the page content, save the current keys
   and afterwards send the request (using the current keys).
   """
   
   def __init__(self, url_data, attack_module, request_type, opts):

       self.opts = opts

       # Call parent class' constructor
       Attack.__init__ (self, url_data, attack_module, request_type, opts)

       # Create link/page parser
       self.form_parser = crawler(self.target_url, opts)
       self.form_parser.setMaxDeep(1)


   def attack(self):
      """
      send the attack (request)
      """

      # found bugs
      vulns = []


      """ First of all get dynamic keys from form """
      # Send crawler get dynamic data, like e.g. keys etc.
      self.form_parser.go()

      # Get the form we're looking for
      _form = None
      for f in self.form_parser.get_forms():

          # Compare both paths
          if f[0] == self.target_url:
              _form = f

      # If form empty abort proceding with next steps
      if not _form:
          print "\n[-] couldn't find form!"
          return

      # ... otherwise use current forms data
      else:
          self.url_data = _form


      """ Send attack """
      # fetch all attack data (type, payloads, success-data)
      self.get_attack_types_from_db()

      # for GET it contains complete attack_url: url + payload
      # for POST it contains form values, which will be replaced by payloads
      values = {}


      for i in range(len(self.attack_data)):
         values = (self.build_attack_url(self.attack_data[i][2]))
         try:
            if self.request_type == 'GET':
               response = self.http_handler.send_GET_request(values)
            elif self.request_type == 'POST':
               response = \
                     self.http_handler.send_POST_request(self.url_data[0], values)
         except NetError, e:
            continue

         # check for vulnerabilities and save them
         check = Check()
         vulnerable = check.check_vuln(self.target_url, values, response,
               self.attack_data[i][3], self.attack_module)

         # Vulnerabilities found
         if vulnerable:
            vulns.append(values)
            sys.stdout.write('F')
         else:
            sys.stdout.write('.')

         sys.stdout.flush()
         
      return vulns
