#    uwss - uber web security scanner
#    Copyright (C) 2009 noptrix & illuminatus
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
# uCheck.py
#
# by noptrix & illuminatus
# www.noptrix.net


class Check():
   """
   check for vulnerabilities
   """

   def __init__(self):
      """
      constructor
      """
      pass

   
   def preprocess_data(self, success_data, attack_response):
      """
      adjust "success_data" and "attack_response", so we can check
      for vulnerabilities
      """

      # split ',' from success_data (e.g.: /bin/sh,/bin/foo,blah) 
      new_success_data = success_data.rsplit(',')

      # replace backslashes, which are inserted by php
      if not attack_response:
         return
      tmp_response = attack_response.read()
      adjusted_response = tmp_response.replace('\\', '')

      return (new_success_data, adjusted_response)


   def check_vuln(self, url, values, response, success_data, attack_module):
      """
      generic vulnerabilities detector

      return data format:
         
         GET-request 
               {'url': url, 'data': payload url}

         POST-request
               {'url': url, 'data': POST data}
      """

      # bug was found ?
      success = 0

      # found report_data
      report_data = {}

      # tmp data, which will be preprocessed for further usage
      tmp_success_data = success_data

      # get the preprocessed data
      (self.success_data, self.adjusted_response) = \
         self.preprocess_data(tmp_success_data, response)
      if not self.success_data or not self.adjusted_response:
         return

      # check, if a vulnerability exists, set the flag
      for i in self.success_data:
         if i in unicode(self.adjusted_response, errors='replace'):
            success = 1

      return success

# EOF
