#    uwss - uber web security scanner
#    Copyright (C) 2009 noptrix & illuminatus
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
# uConfig.py
#
# by noptrix & illuminatus
# www.noptrix.net

"""
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                 General settings - version, usage,verbosity  ...
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
"""

UWSS_VERSION = "0.0.1"

UWSS_BANNER = "-----------------------------------------------------------\n"\
              "[u]ber [w]eb [s]ecurity [s]canner - http://www.noptrix.net/\n"\
              "-----------------------------------------------------------"

# for OptionParser
usage = 'USAGE: 1) crawl:   ./%prog -f <file> -c\n' \
      + '       2) scan:    ./%prog -f <file> -m <module> [options]'
version = '%prog ' + UWSS_VERSION


# Debug modus: Set to '1' to print debug messages
# Verbosity level
#   0: Silent
#   1: Be verbose
opts = {"DEBUG": 0,"VERBOSE": 0}


"""
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                String templates - Used for verbose messages
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
"""
""" -------------- Attack modes ---------------- """
ATTACK_MODES   = "[+] available attack modes:\n" \
                 "[*] generic [default]\n" \
                 "[*] dynamic_keys - crawl page before sending POST requests"
                 
""" -------------- Attack modules -------------- """
ATTACK_MODULES = "[+] available attack modules:\n" \
                 "[*] xss  - cross site scripting\n" \
                 "[*] sql  - sql injection\n" \
                 "[*] file - local/remote file inclusion\n" \
                 "[*] php  - php code injection\n" \
                 "[*] perl - perl/cgi code injection\n" \
                 "[*] ldap - ldap injection\n" \
                 "[*] soap - soap injection\n" \
                 "[*] xml  - xml/xpath injection\n" \
                 "[*] os   - os command injection\n" \
                 "[*] all  - use all modules [default]"

DONE_MSG          = ""
BEGIN_ATTACKS     = ""
END_ATTACKS       = "#" * 100
START_ATTACK_MSG  = "[+] checking: %s ..."
STOP_ATTACK_MSG   = DONE_MSG + "\n[-] finished: %s\n\n"


""" -------------- Report styles -------------- """
REPORT_STYLES = "[+] available report styles:\n" \
                "[*] xml    - output results to xml file\n" \
                "[*] txt    - output results to text file\n" \
                "[*] stdout - output results to stdout [default]"

BEGIN_REPORTING = ""
BEGIN_AUTHENTIFICATION = "[+] authenticating to server..." 
END_AUTHENTIFICATION = DONE_MSG + "[+] saved data to cookie: %s"


BEGIN_CRAWLER = "[+] crawling site..."

END_CRAWLER   = "[+] finished crawling -> Links: %d / Forms: %d\n"

GET_REQUEST_MSG   = "[+] sending GET requests..."
POST_REQUEST_MSG  = "[+] sending POST requests..."

                
GOOD_BYE = "hope it helped...good bye!"


"""
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                Configuration - Default values, paths etc.
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
"""

# List of available modules
attack_modules = {
       'xss': 'xss', 'sql': 'sql_injection', 'file': 'file_inclusion',
       'php': 'php_injection', 'perl': 'perl_cgi_injection',
       'ldap': 'ldap_injection', 'soap': 'soap_injection', 
       'xml': 'xml_injection', 'os': 'os_cmd_injection'
      }

# List of available attack types
attack_modes = {
       'generic': 'generic',
       'dynamic_keys': 'post_dynamic_keys'
}

# List of reporting styles
report_styles = ['stdout', 'xml', 'text']

# logfiles
UWSS_XML_LOGFILE = "uwss.xml"
UWSS_TXT_LOGFILE = "uwss.txt"


# values of parameters
# %CHANGEME% will be replaced by our payloads
CHANGEME = "%CHANGEME%"


# EOF
