#    uwss - uber web security scanner
#    Copyright (C) 2009 noptrix & illuminatus
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
# uCookie.py
#
# by noptrix & illuminatus
# www.noptrix.net

import Cookie
import cookielib
import urllib2
import os

class cooky:
   """ Class to handle cookies

       Attributes:
       -------------------------------
       cj:
         Cookie JAR (see Python documentation)

       cookies:
         User cookies


       Methods:
       -------------------------------
       __init__ (options)
         Creates the cookie jar

       save(filename):
         Save collected cookies to file

       load(filename):
         Load cookies from file

   """
   cj = None                                         # Cookie jar
   cookies = {}                                      # several cookies


   def __init__(self, opts):
      self.opts = opts
      # Create cookie jar
      self.cj = cookielib.LWPCookieJar()


   def save(self, filename):
      """ Save cookies to file """
      if not os.path.isfile(filename):
         # Create file
         fd = open(filename,'w')
         fd.close()

     
      #----------------------------------------------------------------
      if self.opts["DEBUG"]:
         print '[DEBUG] cooky.save: filename = %s' % filename
      #----------------------------------------------------------------

      self.cj.save(filename,ignore_discard=True)


   def load(self, filename):
      """ Load cookies from file """
      if os.path.isfile(filename):
         #----------------------------------------------------------------
         if self.opts["DEBUG"]:
            print '[DEBUG] cooky.load: filename = %s' % filename
         #----------------------------------------------------------------

         self.cj.load(filename)


# EOF
